Ginkgo: gko::preconditioner::Isai< IsaiType, ValueType, IndexType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::preconditioner::Isai< IsaiType, ValueType, IndexType > Class Template Reference
Linear Operators » Preconditioners | Linear Operators

The Incomplete Sparse Approximate Inverse (ISAI) Preconditioner generates an approximate inverse matrix for a given square matrix A, lower triangular matrix L, upper triangular matrix U or symmetric positive (spd) matrix B. More...

`#include <ginkgo/core/preconditioner/isai.hpp>`

Inheritance diagram for gko::preconditioner::Isai< IsaiType, ValueType, IndexType >:
[legend]
Collaboration diagram for gko::preconditioner::Isai< IsaiType, ValueType, IndexType >:
[legend]

## Classes
struct | parameters_type
class | Factory

## Public Types
using | value_type = ValueType
using | index_type = IndexType
using | transposed_type
using | Comp = Composition<ValueType>
using | Csr = matrix::Csr<ValueType, IndexType>
using | Dense = matrix::Dense<ValueType>
Public Types inherited from gko::EnablePolymorphicAssignment< Isai< IsaiType, ValueType, IndexType > >
using | result_type

## Public Member Functions
std::shared_ptr< const typename std::conditional< IsaiType==isai_type::spd, Comp, Csr >::type > | get_approximate_inverse () const
| Returns the approximate inverse of the given matrix (either a CSR matrix for IsaiType general, upper or lower or a composition of two CSR matrices for IsaiType spd).
Isai & | operator= (const Isai &other)
| Copy-assigns an ISAI preconditioner.
Isai & | operator= (Isai &&other)
| Move-assigns an ISAI preconditioner.
| Isai (const Isai &other)
| Copy-constructs an ISAI preconditioner.
| Isai (Isai &&other)
| Move-constructs an ISAI preconditioner.
const parameters_type & | get_parameters () const
std::unique_ptr< LinOp > | transpose () const override
| Returns a LinOp representing the transpose of the Transposable object.
std::unique_ptr< LinOp > | conj_transpose () const override
| Returns a LinOp representing the conjugate transpose of the Transposable object.
Public Member Functions inherited from gko::EnableLinOp< Isai< IsaiType, ValueType, IndexType > >
const Isai< IsaiType, ValueType, IndexType > * | apply (ptr_param< const LinOp > b, ptr_param< LinOp > x) const
Public Member Functions inherited from gko::EnablePolymorphicAssignment< Isai< IsaiType, ValueType, IndexType > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override

## Static Public Member Functions
static auto | build () -> decltype(Factory::create())
static parameters_type | parse (const config::pnode &config, const config::registry &context, const config::type_descriptor &td_for_child=config::make_type_descriptor< ValueType, IndexType >())
| Create the parameters from the property_tree.

## Static Public Attributes
static constexpr isai_type | type {IsaiType}

## Friends
class | EnableLinOp< Isai >
class | EnablePolymorphicObject< Isai, LinOp >
class | Isai< isai_type::general, ValueType, IndexType >
class | Isai< isai_type::lower, ValueType, IndexType >
class | Isai< isai_type::upper, ValueType, IndexType >
class | Isai< isai_type::spd, ValueType, IndexType >

## Detailed Description

template<isai_type IsaiType, typename ValueType, typename IndexType>
class gko::preconditioner::Isai< IsaiType, ValueType, IndexType >

The Incomplete Sparse Approximate Inverse (ISAI) Preconditioner generates an approximate inverse matrix for a given square matrix A, lower triangular matrix L, upper triangular matrix U or symmetric positive (spd) matrix B.

Using the preconditioner computes , , or (depending on the type of the Isai) for a given vector x (may have multiple right hand sides). aiA, aiU and aiL are the approximate inverses for A, U and L respectively. aiC is an approximation to C, the exact Cholesky factor of B (This is commonly referred to as a Factorized Sparse Approximate Inverse, short FSPAI).

The sparsity pattern used for the approximate inverse of A, L and U is the same as the sparsity pattern of the respective matrix. For B, the sparsity pattern used for the approximate inverse is the same as the sparsity pattern of the lower triangular half of B.

Note that, except for the spd case, for a matrix A generally ISAI(A)^T != ISAI(A^T).

For more details on the algorithm, see the paper Incomplete Sparse Approximate Inverses for Parallel Preconditioning, which is the basis for this work.

Note
  GPU implementations can only handle the vector unit width width (warp size for CUDA) as number of elements per row in the sparse matrix. If there are more than width elements per row, the remaining elements will be ignored.

Template Parameters

  IsaiType | determines if the ISAI is generated for a general square matrix, a lower triangular matrix, an upper triangular matrix or an spd matrix
  ValueType | precision of matrix elements
  IndexType | precision of matrix indexes

## Member Typedef Documentation

## ◆ transposed_type

template<isai_type IsaiType, typename ValueType, typename IndexType>

using gko::preconditioner::Isai< IsaiType, ValueType, IndexType >::transposed_type

Initial value:
Isai<IsaiType == isai_type::general ? isai_type::general
: IsaiType == isai_type::spd ? isai_type::spd
: IsaiType == isai_type::lower ? isai_type::upper
: isai_type::lower,
ValueType, IndexType>
gko::preconditioner::Isai::Isai
Isai(const Isai &other)
Copy-constructs an ISAI preconditioner.

## Constructor & Destructor Documentation

## ◆ Isai() [1/2]

template<isai_type IsaiType, typename ValueType, typename IndexType>

gko::preconditioner::Isai< IsaiType, ValueType, IndexType >::Isai | ( | const Isai< IsaiType, ValueType, IndexType > & | other | ) |

Copy-constructs an ISAI preconditioner.

Inherits the executor, shallow-copies the matrix and parameters.

## ◆ Isai() [2/2]

template<isai_type IsaiType, typename ValueType, typename IndexType>

gko::preconditioner::Isai< IsaiType, ValueType, IndexType >::Isai | ( | Isai< IsaiType, ValueType, IndexType > && | other | ) |

Move-constructs an ISAI preconditioner.

Inherits the executor, moves the matrix and parameters. The moved-from object is empty (0x0 with nullptr matrix and default parameters)

## Member Function Documentation

## ◆ conj_transpose()

template<isai_type IsaiType, typename ValueType, typename IndexType>

std::unique_ptr< LinOp > gko::preconditioner::Isai< IsaiType, ValueType, IndexType >::conj_transpose | ( |  | ) | const
| overridevirtual

Returns a LinOp representing the conjugate transpose of the Transposable object.

Returns
  a pointer to the new conjugate transposed object

Implements gko::Transposable.

## ◆ get_approximate_inverse()

template<isai_type IsaiType, typename ValueType, typename IndexType>

std::shared_ptr< const typename std::conditional< IsaiType==isai_type::spd, Comp, Csr >::type > gko::preconditioner::Isai< IsaiType, ValueType, IndexType >::get_approximate_inverse | ( |  | ) | const
| inline

Returns the approximate inverse of the given matrix (either a CSR matrix for IsaiType general, upper or lower or a composition of two CSR matrices for IsaiType spd).

Returns
  the generated approximate inverse

## ◆ operator=() [1/2]

template<isai_type IsaiType, typename ValueType, typename IndexType>

Isai & gko::preconditioner::Isai< IsaiType, ValueType, IndexType >::operator= | ( | const Isai< IsaiType, ValueType, IndexType > & | other | ) |

Copy-assigns an ISAI preconditioner.

Preserves the executor, shallow-copies the matrix and parameters. Creates a clone of the matrix if it is on the wrong executor.

## ◆ operator=() [2/2]

template<isai_type IsaiType, typename ValueType, typename IndexType>

Isai & gko::preconditioner::Isai< IsaiType, ValueType, IndexType >::operator= | ( | Isai< IsaiType, ValueType, IndexType > && | other | ) |

Move-assigns an ISAI preconditioner.

Preserves the executor, moves the matrix and parameters. Creates a clone of the matrix if it is on the wrong executor. The moved-from object is empty (0x0 with nullptr matrix and default parameters)

## ◆ parse()

template<isai_type IsaiType, typename ValueType, typename IndexType>

parameters_type gko::preconditioner::Isai< IsaiType, ValueType, IndexType >::parse | ( | const config::pnode & | config,
|  | const config::registry & | context,
|  | const config::type_descriptor & | td_for_child = config::make_type_descriptor< ValueType, IndexType >() )
| static

Create the parameters from the property_tree.

Because this is directly tied to the specific type, the value/index type settings within config are ignored and type_descriptor is only used for children configs.

Parameters

  config | the property tree for setting
  context | the registry
  td_for_child | the type descriptor for children configs. The default uses the value/index type of this class.

Returns
  parameters

## ◆ transpose()

template<isai_type IsaiType, typename ValueType, typename IndexType>

std::unique_ptr< LinOp > gko::preconditioner::Isai< IsaiType, ValueType, IndexType >::transpose | ( |  | ) | const
| overridevirtual

Returns a LinOp representing the transpose of the Transposable object.

Returns
  a pointer to the new transposed object

Implements gko::Transposable.

The documentation for this class was generated from the following file:

- ginkgo/core/preconditioner/isai.hpp